org.apache.solr.search

## Class LFUCache<K,V>

- java.lang.Object
- - org.apache.solr.search.LFUCache<K,V>

- All Implemented Interfaces:
    SolrInfoMBean, SolrCache<K,V>

      public class LFUCache<K,V>
      extends Object
      implements SolrCache<K,V>

  SolrCache based on ConcurrentLFUCache implementation.

  This implementation does not use a separate cleanup thread. Instead it uses the calling thread itself to do the cleanup when the size of the cache exceeds certain limits.

  Also see SolrCaching

  This API is experimental and subject to change

  Since:
    solr 3.6
  See Also:
    `ConcurrentLFUCache`, `SolrCache`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.solr.search.SolrCache

      `SolrCache.State`

    - ### Nested classes/interfaces inherited from interface org.apache.solr.core.SolrInfoMBean

      `SolrInfoMBean.Category`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LFUCache()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` :TODO: copy from Map
    `void` | `close()` Frees any non-memory resources
    `V` | `get(K key)` :TODO: copy from Map
    `SolrInfoMBean.Category` | `getCategory()` Purpose of this Class
    `String` | `getDescription()` Simple one or two line description
    `URL[]` | `getDocs()` Documentation URL list.
    `String` | `getName()` Simple common usage name, e.g.
    `String` | `getSource()` CVS Source, SVN Source, etc
    `SolrCache.State` | `getState()` Returns the last State set on this instance
    `NamedList` | `getStatistics()` Any statistics this instance would like to be publicly available via the Solr Administration interface.
    `String` | `getVersion()` Simple common usage version, e.g.
    `Object` | `init(Map args, Object persistence, CacheRegenerator regenerator)` The initialization routine.
    `String` | `name()` Name the Cache can be referenced with by SolrRequestHandlers.
    `V` | `put(K key, V value)` :TODO: copy from Map
    `void` | `setState(SolrCache.State state)` Set different cache states.
    `int` | `size()` :TODO: copy from Map
    `String` | `toString()`
    `void` | `warm(SolrIndexSearcher searcher, SolrCache old)` Warm this cache associated with `searcher` using the `old` cache object.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### LFUCache

          public LFUCache()

  - ### Method Detail

    - #### init

          public Object init(Map args,
                             Object persistence,
                             CacheRegenerator regenerator)

      Description copied from interface: `SolrCache`
      The initialization routine. Instance specific arguments are passed in the `args` map.

      The persistence object will exist across different lifetimes of similar caches. For example, all filter caches will share the same persistence object, sometimes at the same time (it must be thread-safe). If null is passed, then the cache implementation should create and return a new persistence object. If not null, the passed in object should be returned again.

      Since it will exist across the lifetime of many caches, care should be taken to not reference any particular cache instance and prevent it from being garbage collected (no using inner classes unless they are static).

      The persistence object is designed to be used as a way for statistics to accumulate across all instances of the same type of cache, however the object may be of any type desired by the cache implementation.

      The `CacheRegenerator` is what the cache uses during auto-warming to regenerate an item in the new cache from an entry in the old cache.

      Specified by:
        `init` in interface `SolrCache<K,V>`

    - #### name

          public String name()

      Description copied from interface: `SolrCache`
      Name the Cache can be referenced with by SolrRequestHandlers. This method must return the identifier that the Cache instance expects SolrRequestHandlers to use when requesting access to it from the SolrIndexSearcher. It is strongly recommended that this method return the value of the "name" parameter from the init args. :TODO: verify this.
      Specified by:
        `name` in interface `SolrCache<K,V>`

    - #### size

          public int size()

      Description copied from interface: `SolrCache`
      :TODO: copy from Map
      Specified by:
        `size` in interface `SolrCache<K,V>`

    - #### put

          public V put(K key,
                       V value)

      Description copied from interface: `SolrCache`
      :TODO: copy from Map
      Specified by:
        `put` in interface `SolrCache<K,V>`

    - #### get

          public V get(K key)

      Description copied from interface: `SolrCache`
      :TODO: copy from Map
      Specified by:
        `get` in interface `SolrCache<K,V>`

    - #### clear

          public void clear()

      Description copied from interface: `SolrCache`
      :TODO: copy from Map
      Specified by:
        `clear` in interface `SolrCache<K,V>`

    - #### setState

          public void setState(SolrCache.State state)

      Description copied from interface: `SolrCache`
      Set different cache states. The state a cache is in can have an effect on how statistics are kept. The cache user (SolrIndexSearcher) will take care of switching cache states.
      Specified by:
        `setState` in interface `SolrCache<K,V>`

    - #### getState

          public SolrCache.State getState()

      Description copied from interface: `SolrCache`
      Returns the last State set on this instance
      Specified by:
        `getState` in interface `SolrCache<K,V>`
      See Also:
        `SolrCache.setState(org.apache.solr.search.SolrCache.State)`

    - #### warm

          public void warm(SolrIndexSearcher searcher,
                           SolrCache old)

      Description copied from interface: `SolrCache`
      Warm this cache associated with `searcher` using the `old` cache object. `this` and `old` will have the same concrete type.
      Specified by:
        `warm` in interface `SolrCache<K,V>`

    - #### close

          public void close()

      Description copied from interface: `SolrCache`
      Frees any non-memory resources
      Specified by:
        `close` in interface `SolrCache<K,V>`

    - #### getName

          public String getName()

      Description copied from interface: `SolrInfoMBean`
      Simple common usage name, e.g. BasicQueryHandler, or fully qualified clas name.
      Specified by:
        `getName` in interface `SolrInfoMBean`

    - #### getVersion

          public String getVersion()

      Description copied from interface: `SolrInfoMBean`
      Simple common usage version, e.g. 2.0
      Specified by:
        `getVersion` in interface `SolrInfoMBean`

    - #### getDescription

          public String getDescription()

      Description copied from interface: `SolrInfoMBean`
      Simple one or two line description
      Specified by:
        `getDescription` in interface `SolrInfoMBean`

    - #### getCategory

          public SolrInfoMBean.Category getCategory()

      Description copied from interface: `SolrInfoMBean`
      Purpose of this Class
      Specified by:
        `getCategory` in interface `SolrInfoMBean`

    - #### getSource

          public String getSource()

      Description copied from interface: `SolrInfoMBean`
      CVS Source, SVN Source, etc
      Specified by:
        `getSource` in interface `SolrInfoMBean`

    - #### getDocs

          public URL[] getDocs()

      Description copied from interface: `SolrInfoMBean`
      Documentation URL list.

      Suggested documentation URLs: Homepage for sponsoring project, FAQ on class usage, Design doc for class, Wiki, bug reporting URL, etc...

      Specified by:
        `getDocs` in interface `SolrInfoMBean`

    - #### getStatistics

          public NamedList getStatistics()

      Description copied from interface: `SolrInfoMBean`
      Any statistics this instance would like to be publicly available via the Solr Administration interface.

      Any Object type may be stored in the list, but only the `toString()` representation will be used.

      Specified by:
        `getStatistics` in interface `SolrInfoMBean`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.